/* -*-C-*-
 * access to the X Window System for Sather
 * (c) 1994/11/11 - 1994/11/28 by Erik Schnetter
 */

#include <alloca.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include "../../System/header.h"



BOOL X_AllocColor (Display* display, INT colormap, INT* ints)
{
  XColor color;
  BOOL res;
  
  color.pixel = ints[0];
  color.red = ints[1];
  color.green = ints[2];
  color.blue = ints[3];
  color.flags = ints[4];
  res = XAllocColor (display, colormap, &color);
  ints[0] = color.pixel;
  ints[1] = color.red;
  ints[2] = color.green;
  ints[3] = color.blue;
  ints[4] = color.flags;
  return res;
}



void X_FreeColors (Display* display, INT colormap, INT pixels[], INT npixels,
		   INT planes)
{
  unsigned long* p;
  
  /* copy array, if necessary */
  if (sizeof(INT) != sizeof(unsigned long)) {
    int i;
    p = (unsigned long*) alloca (npixels * sizeof(unsigned long));
    for (i=npixels; i--;) p[i]=pixels[i];
  } else {
    p = (unsigned long*) pixels;
  }
  XFreeColors (display, colormap, p, npixels, planes);
}
