#define DETERMINISTIC
#include "GC/gc.h"
#include "header.h"

extern BOOL deterministic;

/* The void * should be fixed up sometime */

INT c_SYS_id_OB_INT(void *s, void* ob) {          /* SYS::id($OB):INT */
    if ((((OB)ob)->header.tag)<0) {
	fprintf(stderr,"Can't call SYS::id($OB):INT on value types.\n");
/*      abort();                                                                -- NLP */
        exit(16);                                                         /*    -- NLP */
    }
    if (deterministic) 
	return ((OB)ob)->header.id;
    else
	return (INT) (((unsigned long)ob)>>2);
}

void c_SYS_destroy_OB(void *s, void* ob) {        /* SYS::destroy($OB) */
    GC_free(ob);
}

INT c_SYS_tp_OB_INT(void *s, void* ob) {          /* SYS::tp($OB) */
    return ((OB)ob)->header.tag;
}
